> ## Documentation Index
> Fetch the complete documentation index at: https://developer.upsun.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List profiling results

> Returns a paginated list of profiles for the environment, optionally filtered by transaction name. Proxied from the Blackfire API.



## OpenAPI

````yaml https://meta.upsun.com/openapi-spec get /projects/{projectId}/environments/{environmentId}/observability/profiles
openapi: 3.0.1
info:
  title: Upsun.com Rest API
  version: '1.0'
  contact:
    name: Support
    url: https://upsun.com/contact-us/
  termsOfService: https://upsun.com/trust-center/legal/tos/
  description: >
    # Introduction


    Upsun, formerly Platform.sh, is a container-based Platform-as-a-Service. Our
    main API

    is simply Git. With a single `git push` and a couple of YAML files in

    your repository you can deploy an arbitrarily complex cluster.

    Every [**Project**](#tag/Project) can have multiple applications (PHP,

    Node.js, Python, Ruby, Go, etc.) and managed, automatically

    provisioned services (databases, message queues, etc.).


    Each project also comes with multiple concurrent

    live staging/development [**Environments**](#tag/Environment).

    These ephemeral development environments

    are automatically created every time you push a new branch or create a

    pull request, and each has a full copy of the data of its parent branch,

    which is created on-the-fly in seconds.


    Our Git implementation supports integrations with third party Git

    providers such as GitHub, Bitbucket, or GitLab, allowing you to simply

    integrate Upsun into your existing workflow.


    ## Using the REST API


    In addition to the Git API, we also offer a REST API that allows you to
    manage

    every aspect of the platform, from managing projects and environments,

    to accessing accounts and subscriptions, to creating robust workflows

    and integrations with your CI systems and internal services.


    These API docs are generated from a standard **OpenAPI (Swagger)**
    Specification document

    which you can find here in [YAML](openapispec-upsun.yaml) and in
    [JSON](openapispec-upsun.json) formats.


    This RESTful API consumes and produces HAL-style JSON over HTTPS,

    and any REST library can be used to access it. On GitHub, we also host

    a few API libraries that you can use to make API access easier, such as our

    [PHP API client](https://github.com/upsun/upsun-sdk-php).


    In order to use the API you will first need to have an [Upsun
    account](https://auth.upsun.com/register/) 

    and [create an API Token](https://docs.upsun.com/anchors/cli/api-token/).


    # Authentication


    ## OAuth2


    API authentication is done with OAuth2 access tokens.


    ### API tokens


    You can use an API token as one way to get an OAuth2 access token. This

    is particularly useful in scripts, e.g. for CI pipelines.


    To create an API token, go to the "API Tokens" section

    of the "Account Settings" tab on the [Console](https://console.upsun.com).


    To exchange this API token for an access token, a `POST` request

    must be made to `https://auth.upsun.com/oauth2/token`.


    The request will look like this in cURL:


    <pre>

    curl -u platform-api-user: \
        -d 'grant_type=api_token&amp;api_token=<em><b>API_TOKEN</b></em>' \
        https://auth.upsun.com/oauth2/token
    </pre>


    This will return a "Bearer" access token that

    can be used to authenticate further API requests, for example:


    <pre>

    {
        "access_token": "<em><b>abcdefghij1234567890</b></em>",
        "expires_in": 900,
        "token_type": "bearer"
    }

    </pre>


    ### Using the Access Token


    To authenticate further API requests, include this returned bearer token

    in the `Authorization` header. For example, to retrieve a list of

    [Projects](#tag/Project)

    accessible by the current user, you can make the following request

    (substituting the dummy token for your own):


    <pre>

    curl -H "Authorization: Bearer <em><b>abcdefghij1234567890</b></em>" \
        https://api.upsun.com/projects
    </pre>


    # HAL Links


    Most endpoints in the API return fields which defines a HAL

    (Hypertext Application Language) schema for the requested endpoint.

    The particular objects returns and their contents can vary by endpoint.

    The payload examples we give here for the requests do not show these

    elements. These links can allow you to create a fully dynamic API client

    that does not need to hardcode any method or schema.


    Unless they are used for pagination we do not show the HAL links in the

    payload examples in this documentation for brevity and as their content

    is contextual (based on the permissions of the user).


    ## _links Objects


    Most endpoints that respond to `GET` requests will include a `_links` object

    in their response. The `_links` object contains a key-object pair labelled
    `self`, which defines

    two further key-value pairs:


    * `href` - A URL string referring to the fully qualified name of the
    returned object. For many endpoints, this will be the direct link to the API
    endpoint on the region gateway, rather than on the general API gateway. This
    means it may reference a host of, for example, `eu-2.platform.sh` rather
    than `api.upsun.com`.

    * `meta` - An object defining the OpenAPI Specification (OAS) [schema
    object](https://swagger.io/specification/#schemaObject) of the component
    returned by the endpoint.


    There may be zero or more other fields in the `_links` object resembling
    fragment identifiers

    beginning with a hash mark, e.g. `#edit` or `#delete`. Each of these keys

    refers to a JSON object containing two key-value pairs:


    * `href` - A URL string referring to the path name of endpoint which can
    perform the action named in the key.

    * `meta` - An object defining the OAS schema of the endpoint. This consists
    of a key-value pair, with the key defining an HTTP method and the value
    defining the [operation
    object](https://swagger.io/specification/#operationObject) of the endpoint.


    To use one of these HAL links, you must send a new request to the URL
    defined

    in the `href` field which contains a body defined the schema object in the
    `meta` field.


    For example, if you make a request such as `GET
    /projects/abcdefghij1234567890`, the `_links`

    object in the returned response will include the key `#delete`. That object

    will look something like this fragment:


    ```

    "#delete": {
        "href": "/api/projects/abcdefghij1234567890",
        "meta": {
            "delete": {
                "responses": {
                    . . . // Response definition omitted for space
                },
                "parameters": []
            }
        }
    }

    ```


    To use this information to delete a project, you would then send a `DELETE`

    request to the endpoint
    `https://api.upsun.com/api/projects/abcdefghij1234567890`

    with no body or parameters to delete the project that was originally
    requested.


    ## _embedded Objects


    Requests to endpoints which create or modify objects, such as `POST`,
    `PATCH`, or `DELETE`

    requests, will include an `_embedded` key in their response. The object

    represented by this key will contain the created or modified object. This

    object is identical to what would be returned by a subsequent `GET` request

    for the object referred to by the endpoint.
  x-logo:
    url: https://docs.upsun.com/images/upsun-api.svg
    href: https://upsun.com/#section/Introduction
    altText: Upsun logo
servers:
  - url: '{schemes}://api.upsun.com'
    description: The Upsun.com API gateway
    variables:
      schemes:
        default: https
security:
  - BearerAuth: []
tags:
  - name: Cert Management
    description: >
      User-supplied SSL/TLS certificates can be managed using these

      endpoints. You can now list and modify certificate provisioners

      using the `/projects/{projectId}/provisioners` and

      `/projects/{projectId}/provisioners/{certificateProvisionerDocumentId}`

      endpoints. For more information, see our

      [Third-party TLS
      certificate](https://docs.upsun.com/anchors/domains/custom/custom-certificates/)

      documentation. These endpoints are not for managing certificates

      that are automatically supplied by Upsun via Let's Encrypt.
  - name: Environment
    description: |
      On Upsun, an environment encompasses a single instance of your
      entire application stack, the services used by the application,
      the application's data storage, and the environment's backups.

      In general, an environment represents a single branch or merge request
      in the Git repository backing a project. It is a virtual cluster
      of read-only application and service containers with read-write
      mounts for application and service data.

      On Upsun, the default branch is your production environment—thus,
      merging changes to this branch will put those changes to production.
  - name: Environment Type
    description: >
      Environment Types is the way Upsun manages access. We currently have 3
      environment types:

      * Development

      * Staging

      * Production


      Each environment type will contain a group of users and their accesses. We
      manage access,

      adding, updating and removing users and their roles, here.


      Each environment will have a type, pointing to one of these 3 environment
      types.

      See `type` in [Environments](#tag/Environment).


      In general:

      * Production will be reserved for the default branch, and cannot be set
      manually.

      * An environment can be set to be type `staging` or development manually
      and when branching.


      Dedicated Generation 2 projects have different rules for environment
      types. If your project

      contains at least one of those Dedicated Generation 2 environments, the
      rules are slightly different:

      * All non-dedicated environments in your project can be `development` or
      `staging`, but never `production`.

      * Dedicated Generation 2 environments can be set either to `staging` or
      `production`, but never `development`.

      * The default branch is not considered to be a special case.
  - name: Environment Backups
    description: |
      A snapshot is a complete backup of an environment, including all the
      persistent data from all services running in an environment and all
      files present in mounted volumes.

      These endpoints can be used to trigger the creation of new backups,
      get information about existing backups, delete existing backups or
      restore a backup.
      More information about backups can be found in our
      [documentation](https://docs.upsun.com/anchors/environments/backup/).
  - name: Environment Variables
    description: >
      These endpoints manipulate user-defined variables which are bound to a

      specific environment, as well as (optionally) the children of an

      environment. These variables can be made available at both build time

      and runtime. For more information on environment variables,

      see the
      [Variables](https://docs.upsun.com/anchors/variables/set/environment/create/)

      section of the documentation.
  - name: Autoscaling
    description: >
      Upsun provides native support for autoscaling, allowing your applications
      to automatically adjust based on resource usage.

      This ensures that your apps remain responsive under load while helping you
      optimize costs.

      You can configure thresholds for metrics such as CPU, RAM, and request
      latency.  

      Resources will automatically scale to meet demand.

      Each container profile assigned to an application or service provides a
      specific combination of CPU and RAM, which you can select via the Upsun UI
      or CLI.


      These endpoints manage autoscaling configurations that are tied to a

      specific environment, and optionally to its child environments.

      You can define scaling rules based on metrics like CPU, memory, or

      request latency, and these rules will be applied at both build time

      and runtime. For more information on configuring autoscaling for your

      environments, see the
      [Autoscaling](https://docs.upsun.com/manage-resources/autoscaling.html)
      section

      of the documentation.
  - name: Project
    description: >
      ## Project Overview


      On Upsun, a Project is backed by a single Git repository

      and encompasses your entire application stack, the services

      used by your application, the application's data storage,

      the production and staging environments, and the backups of those

      environments.


      When you create a new project, you start with a single

      [Environment](#tag/Environment) called *Master*,

      corresponding to the master branch in the Git repository of

      the project—this will be your production environment.


      If you connect your project to an external Git repo

      using one of our [Third-Party Integrations](#tag/Third-Party-Integrations)

      a new development environment can be created for each branch

      or pull request created in the repository. When a new development

      environment is created, the production environment's data

      will be cloned on-the-fly, giving you an isolated, production-ready

      test environment.


      This set of API endpoints can be used to retrieve a list of projects

      associated with an API key, as well as create and update the parameters

      of existing projects.


      > **Note**:

      >

      > To list projects or to create a new project, use
      [`/subscriptions`](#tag/Subscriptions).
  - name: Project Variables
    description: >
      These endpoints manipulate user-defined variables which are bound to an

      entire project. These variables are accessible to all environments

      within a single project, and they can be made available at both build

      time and runtime. For more information on project variables,

      see the
      [Variables](https://docs.upsun.com/anchors/variables/set/project/create/)

      section of the documentation.
  - name: Project Settings
    description: >
      These endpoints can be used to retrieve and manipulate project-level

      settings. Only the `initialize` property can be set by end users. It is
      used

      to initialize a project from an existing Git repository.


      The other properties can only be set by a privileged user.
  - name: Repository
    description: >
      The Git repository backing projects hosted on Upsun can be

      accessed in a **read-only** manner through the
      `/projects/{projectId}/git/*`

      family of endpoints. With these endpoints, you can retrieve objects from

      the Git repository in the same way that you would in a local environment.
  - name: Domain Management
    description: |
      These endpoints can be used to add, modify, or remove domains from
      a project. For more information on how domains function on
      Upsun, see the [Domains](https://docs.upsun.com/anchors/domains/custom/)
      section of our documentation.
  - name: Routing
    description: >
      These endpoints modify an environment's `routes:` section of the
      `.upsun/config.yaml` file.

      For routes to propagate to child environments, the child environments

      must be synchronized with their parent.


      More information about routing can be found in the
      [Routes](https://docs.upsun.com/anchors/routes/)

      section of the documentation.
  - name: Source Operations
    description: >
      These endpoints interact with source code operations as defined in the
      `source.operations`

      key in a project's `.upsun/config.yaml` configuration. More information

      on source code operations is

      [available in our user
      documentation](https://docs.upsun.com/anchors/app/source-operations/).
  - name: Deployment Target
    description: |
      Upsun is capable of deploying the production environments of
      projects in multiple topologies: both in clusters of containers, and
      as dedicated virtual machines. This is an internal API that can
      only be used by privileged users.
  - name: Deployments
    description: |
      The deployments endpoints gives detailed information about the actual
      deployment of an active environment. Currently, it returns the _current_
      deployment with information about the different apps, services, and
      routes contained within.
  - name: Third-Party Integrations
    description: |
      Upsun can easily integrate with many third-party services, including
      Git hosting services (GitHub, GitLab, and Bitbucket),
      health notification services (email, Slack, PagerDuty),
      performance analytics platforms (New Relic, Blackfire, Tideways),
      and webhooks.

      For clarification about what information each field requires, see the
      [External Integrations](https://docs.upsun.com/anchors/integrations/)
      documentation. NOTE: The names of the CLI arguments listed in the
      documentation are not always named exactly the same as the
      required body fields in the API request.
  - name: MFA
    description: >
      Multi-factor authentication (MFA) requires the user to present two (or
      more) types of evidence (or factors) to prove their identity.


      For example, the evidence might be a password and a device-generated code,
      which show the user has the knowledge factor ("something you know") 

      as well as the possession factor ("something you have"). In this way MFA
      offers good protection against the compromise of any single factor, 

      such as a stolen password.


      Using the MFA API you can set up time-based one-time passcodes (TOTP),
      which can be generated on a single registered device ("something you
      have") such as a mobile phone.
  - name: Subscriptions
    description: >
      Each project is represented by a subscription that holds the plan
      information.

      These endpoints can be used to go to a larger plan, add more storage, or
      subscribe to

      optional features.
  - name: Orders
    description: |
      These endpoints can be used to retrieve order information from our billing
      system. Here you can view information about your bill for our services,
      include the billed amount and a link to a PDF of the bill.
  - name: Invoices
    description: >
      These endpoints can be used to retrieve invoices from our billing system.

      An invoice of type "invoice" is generated automatically every month, if
      the customer has active projects.

      Invoices of type "credit_memo" are a result of manual action when there
      was a refund or an invoice correction.
  - name: Vouchers
    description: >
      These endpoints can be used to retrieve vouchers associated with a
      particular

      user as well as apply a voucher to a particular user.
  - name: Records
    description: >
      These endpoints retrieve information about which plans were assigned to a
      particular

      project at which time.
  - name: Support
    description: >
      These endpoints can be used to retrieve information about support ticket
      priority

      and allow you to submit new ticket to the Upsun Support Team.
  - name: System Information
    description: >
      These endpoints can be used to retrieve low-level information and interact
      with the

      core component of Upsun infrastructure.


      This is an internal API that can only be used by privileged users.
paths:
  /projects/{projectId}/environments/{environmentId}/observability/profiles:
    get:
      tags:
        - Blackfire Profiling
      summary: List profiling results
      description: >-
        Returns a paginated list of profiles for the environment, optionally
        filtered by transaction name. Proxied from the Blackfire API.
      operationId: blackfire_profiles_list
      parameters:
        - name: projectId
          in: path
          description: The unique identifier of the Upsun project
          required: true
          schema:
            type: string
            pattern: '[a-z0-9]+'
            example: abc123def456
        - name: environmentId
          in: path
          description: The environment identifier
          required: true
          schema:
            type: string
            pattern: .+
            example: main
        - name: transaction
          in: query
          description: Filter by transaction name (exact match).
          required: false
          schema:
            type: string
            example: App\Controller\ProductController::list
        - name: page
          in: query
          description: Page number for pagination.
          required: false
          schema:
            type: integer
            default: null
            minimum: 1
        - name: limit
          in: query
          description: Number of profiles per page.
          required: false
          schema:
            type: integer
            minimum: 1
            maximum: 100
            default: null
        - name: url
          in: query
          description: Wildcard search across URI, name, and transaction name.
          required: false
          schema:
            type: string
            example: /api/products
        - name: is_auto
          in: query
          description: When false, excludes auto-triggered (APM) profiles from results.
          required: false
          schema:
            type: boolean
            example: false
        - name: is_public
          in: query
          description: Filter to public profiles only when set to "true".
          required: false
          schema:
            type: string
            example: 'true'
            enum:
              - 'true'
              - 'false'
        - name: sort_by
          in: query
          description: Field to sort results by.
          required: false
          schema:
            type: string
            example: date
            default: null
            enum:
              - date
              - wt
              - io
              - cpu
              - pmu
              - nw
              - sql
              - http
        - name: sort_order
          in: query
          description: Sort direction.
          required: false
          schema:
            type: string
            example: desc
            default: null
            enum:
              - asc
              - desc
        - name: start_date
          in: query
          description: Filter profiles created after this date (ISO 8601).
          required: false
          schema:
            type: string
            format: date-time
            example: '2026-01-01T00:00:00+00:00'
        - name: end_date
          in: query
          description: Filter profiles created before this date (ISO 8601).
          required: false
          schema:
            type: string
            format: date-time
            example: '2026-12-31T23:59:59+00:00'
        - name: status_code
          in: query
          description: >-
            Filter by profile status code: -1=empty, 0=todo,
            16=payment_required, 32=too_many_subprofiles, 64=done, 128=failed,
            192=rejected.
          required: false
          schema:
            type: integer
            example: 64
            enum:
              - -1
              - 0
              - 16
              - 32
              - 64
              - 128
              - 192
        - name: owner
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/FilterSelect'
        - name: languages
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/FilterSelect'
        - name: frameworks
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/FilterSelect'
        - name: items_per_page
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            maximum: 100
            default: null
      responses:
        '200':
          description: Profiles retrieved successfully
          content:
            application/json:
              schema:
                required:
                  - _project_id
                  - _environment_id
                  - _branch_machine_name
                  - _agent
                  - profiles
                  - page
                  - pages
                  - total
                properties:
                  _project_id:
                    description: Project identifier
                    type: string
                    example: abc123def456
                  _environment_id:
                    description: Environment identifier
                    type: string
                    example: main
                  _branch_machine_name:
                    description: Branch machine name
                    type: string
                    example: main-bvxea6i
                  _agent:
                    description: Blackfire Agent UUID
                    type: string
                    format: uuid
                    example: a38f69ca-3b56-4ea6-beac-272b2568164a
                  profiles:
                    description: List of profiles
                    type: array
                    items:
                      required:
                        - uuid
                        - name
                        - _links
                      properties:
                        uuid:
                          description: Profile UUID
                          type: string
                          format: uuid
                          example: 4b5266a2-fd71-468b-bf05-87b342079cbf
                        name:
                          description: Profile name
                          type: string
                          example: POST /api/cart
                        created_at:
                          description: Profile creation date (ISO 8601)
                          type: string
                          format: date-time
                          example: 2026-03-26T14:31:49+0000
                        updated_at:
                          description: Profile last update date (ISO 8601)
                          type: string
                          format: date-time
                          example: 2026-03-26T14:31:52+0000
                        metadata:
                          description: >-
                            Profile metadata (language, framework, transaction
                            name, etc.)
                          type: object
                        data:
                          description: Profile performance data
                          properties:
                            envelope:
                              description: Aggregate performance metrics
                              properties:
                                wt:
                                  description: Wall time (microseconds)
                                  type: number
                                  example: 143341
                                cpu:
                                  description: CPU time (microseconds)
                                  type: number
                                  example: 113242
                                io:
                                  description: I/O time (microseconds)
                                  type: number
                                  example: 30099
                                pmu:
                                  description: Peak memory usage (bytes)
                                  type: number
                                  example: 5990880
                                mu:
                                  description: Memory usage (bytes)
                                  type: number
                                  example: 6301320
                                nw:
                                  description: Network I/O (bytes)
                                  type: number
                                  example: 739
                                ct:
                                  description: Call count
                                  type: number
                                  example: 1
                              type: object
                            important_metrics:
                              description: Pre-aggregated SQL and HTTP metrics
                              properties:
                                sql_queries:
                                  properties:
                                    ct:
                                      description: Number of SQL queries
                                      type: number
                                      example: 5
                                    wt:
                                      description: Total SQL wall time (microseconds)
                                      type: number
                                      example: 7004
                                  type: object
                                http_requests:
                                  properties:
                                    ct:
                                      description: Number of HTTP requests
                                      type: number
                                      example: 1
                                    wt:
                                      description: Total HTTP wall time (microseconds)
                                      type: number
                                      example: 11
                                  type: object
                              type: object
                          type: object
                        recommendations:
                          description: Number of recommendation constraints evaluated
                          type: integer
                          example: 4
                          nullable: true
                        context:
                          description: Request context (HTTP or CLI)
                          properties:
                            uri:
                              description: Full request URI (HTTP profiles)
                              type: string
                              example: https://example.com/api/v2/builds
                            method:
                              description: HTTP method
                              type: string
                              example: POST
                            status_code:
                              description: HTTP response status code
                              type: integer
                              example: 200
                            path:
                              description: Request path
                              type: string
                              example: /api/v2/builds
                            type:
                              description: Context type
                              type: string
                              example: http-request
                              enum:
                                - http-request
                                - cli
                                - no-op
                            args:
                              description: Command arguments (CLI profiles)
                              type: array
                              items:
                                type: string
                          type: object
                        status_code:
                          description: >-
                            Profile processing status: 64=done, 128=failed,
                            0=todo, -1=empty, 16=payment_required,
                            32=too_many_subprofiles, 192=rejected
                          type: integer
                          example: 64
                        status_name:
                          description: Human-readable profile status
                          type: string
                          example: finished
                        owner:
                          description: Profile owner
                          properties:
                            uuid:
                              type: string
                              format: uuid
                            name:
                              type: string
                              example: John Doe
                            avatar:
                              type: string
                              format: uri
                          type: object
                        agent:
                          description: Blackfire agent/environment info
                          properties:
                            uuid:
                              type: string
                              format: uuid
                            name:
                              type: string
                            env_uuid:
                              type: string
                              format: uuid
                            is_env:
                              type: boolean
                          type: object
                        has_timeline:
                          description: Whether the profile has timeline data
                          type: boolean
                          example: true
                        is_public:
                          description: Whether the profile is publicly shared
                          type: boolean
                          example: false
                        is_readonly:
                          description: Whether the profile is read-only
                          type: boolean
                          example: false
                        is_comparison:
                          description: Whether this is a comparison profile
                          type: boolean
                          example: false
                        caches:
                          description: Cache statistics (OPcache, APCu, realpath, PCRE)
                          type: object
                        report:
                          description: Test report with constraints and assertions
                          type: object
                          nullable: true
                        key_page:
                          description: Key page / transaction configuration
                          type: object
                        _links:
                          description: >-
                            Profile navigation links. Links with type
                            "text/html" are web pages for humans. Links with
                            type "application/json" are API endpoints returning
                            JSON.
                          required:
                            - api_subprofiles
                            - api_profile
                            - api_graph
                          properties:
                            graph_url:
                              required:
                                - href
                                - type
                              properties:
                                href:
                                  type: string
                                  format: uri
                                  example: >-
                                    https://blackfire.io/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/graph
                                type:
                                  type: string
                                  example: text/html
                                  enum:
                                    - text/html
                              type: object
                              additionalProperties: false
                            api_timeline:
                              description: API endpoint for timeline data (JSON)
                              required:
                                - href
                                - type
                              properties:
                                href:
                                  type: string
                                  format: uri
                                  example: >-
                                    https://api.upsun.com/projects/abc123/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/timeline
                                type:
                                  type: string
                                  example: application/json
                                  enum:
                                    - application/json
                              type: object
                              additionalProperties: false
                            api_subprofiles:
                              description: API endpoint for subprofiles data (JSON)
                              required:
                                - href
                                - type
                              properties:
                                href:
                                  type: string
                                  format: uri
                                  example: >-
                                    https://api.upsun.com/projects/abc123/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/subprofiles
                                type:
                                  type: string
                                  example: application/json
                                  enum:
                                    - application/json
                              type: object
                              additionalProperties: false
                            api_profile:
                              description: API endpoint for profile details (JSON)
                              required:
                                - href
                                - type
                              properties:
                                href:
                                  type: string
                                  format: uri
                                  example: >-
                                    https://api.upsun.com/projects/abc123/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/profile
                                type:
                                  type: string
                                  example: application/json
                                  enum:
                                    - application/json
                              type: object
                              additionalProperties: false
                            api_graph:
                              description: API endpoint for call graph data (JSON)
                              required:
                                - href
                                - type
                              properties:
                                href:
                                  type: string
                                  format: uri
                                  example: >-
                                    https://api.upsun.com/projects/abc123/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/graph
                                type:
                                  type: string
                                  example: application/json
                                  enum:
                                    - application/json
                              type: object
                              additionalProperties: false
                          type: object
                      type: object
                  page:
                    description: Current page number
                    type: integer
                    example: 1
                  pages:
                    description: Total number of pages
                    type: integer
                    example: 3
                  total:
                    description: Total number of profiles
                    type: integer
                    example: 25
                type: object
                additionalProperties: false
              example:
                _project_id: abc123def456
                _environment_id: main
                _branch_machine_name: main-bvxea6i
                _agent: a38f69ca-3b56-4ea6-beac-272b2568164a
                profiles:
                  - uuid: 4b5266a2-fd71-468b-bf05-87b342079cbf
                    name: POST /api/cart
                    created_at: 2026-03-26T14:31:49+0000
                    updated_at: 2026-03-26T14:31:52+0000
                    metadata:
                      Triggered by: apm
                      Transaction Name: App\Controller\CartController::add
                      Language: php
                      Frameworks:
                        - symfony_framework
                    data:
                      envelope:
                        wt: 143341
                        cpu: 113242
                        io: 30099
                        pmu: 5990880
                        mu: 6301320
                        nw: 739
                        ct: 1
                      important_metrics:
                        sql_queries:
                          ct: 5
                          wt: 7004
                        http_requests:
                          ct: 1
                          wt: 11
                    recommendations: 4
                    context:
                      uri: https://example.com/api/cart
                      method: POST
                      status_code: 200
                      path: /api/cart
                      type: http-request
                    status_code: 64
                    status_name: finished
                    owner:
                      uuid: 4aed4f5d-e0cb-4320-902f-885fddaa7d15
                      name: John Doe
                    agent:
                      uuid: a38f69ca-3b56-4ea6-beac-272b2568164a
                      name: Production
                      env_uuid: a38f69ca-3b56-4ea6-beac-272b2568164a
                      is_env: true
                    has_timeline: true
                    is_public: false
                    is_readonly: false
                    is_comparison: false
                    caches:
                      opcache:
                        enabled: true
                        hitrate: 0.99
                        items: 5128
                    _links:
                      graph_url:
                        href: >-
                          https://blackfire.io/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/graph
                        type: text/html
                      api_timeline:
                        href: >-
                          https://api.upsun.com/projects/abc123def456/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/timeline
                        type: application/json
                      api_subprofiles:
                        href: >-
                          https://api.upsun.com/projects/abc123def456/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/subprofiles
                        type: application/json
                      api_profile:
                        href: >-
                          https://api.upsun.com/projects/abc123def456/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/profile
                        type: application/json
                      api_graph:
                        href: >-
                          https://api.upsun.com/projects/abc123def456/environments/main/observability/profiles/4b5266a2-fd71-468b-bf05-87b342079cbf/graph
                        type: application/json
                page: 1
                pages: 3
                total: 25
        '400':
          description: >-
            Bad request - Invalid parameters. Please consult the API
            documentation to fix the request parameters.
          content:
            application/json:
              schema:
                required:
                  - type
                  - title
                  - status
                  - violations
                properties:
                  type:
                    description: RFC 2616 reference URL identifying the error type
                    type: string
                    format: uri
                    example: https://tools.ietf.org/html/rfc2616#section-1
                  title:
                    description: Human-readable summary of the validation error
                    type: string
                    example: Please ensure parameters are correct.
                  status:
                    description: HTTP status code
                    type: integer
                    example: 400
                  violations:
                    description: >-
                      Map of parameter names to their validation errors. Each
                      parameter can have multiple error messages.
                    type: object
                    example:
                      grain:
                        - Grain can not be larger than the selection windows.
                      from:
                        - The from timestamp must be in the past.
                      to:
                        - >-
                          The to timestamp must be greater than the from
                          timestamp.
                    additionalProperties:
                      type: array
                      items:
                        type: string
                        example: The from timestamp must be in the past.
                type: object
                additionalProperties: false
        '403':
          description: >-
            Forbidden - Access denied due to insufficient permissions, or the
            requested project/environment does not exist (to prevent information
            disclosure)
components:
  schemas:
    FilterSelect:
      properties:
        mode:
          $ref: '#/components/schemas/Mode'
        values:
          oneOf:
            - type: array
              items:
                nullable: true
                type: string
            - type: object
              additionalProperties:
                nullable: true
                type: string
          default: null
      type: object
    Mode:
      type: string
      enum:
        - '1'
        - '-1'
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````